unit PostXML;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ O錾 }

  IXMLMethodResponseType = interface;
  IXMLParamsType = interface;
  IXMLParamType = interface;
  IXMLValueType = interface;
  IXMLStructType = interface;
  IXMLMemberType = interface;
  IXMLArrayType = interface;
  IXMLDataType = interface;

{ IXMLMethodResponseType }

  IXMLMethodResponseType = interface(IXMLNode)
    ['{0BFEC02F-233E-42B1-8FA5-BD0CDBC09CE5}']
    { vpeBQƊ֐ }
    function Get_Params: IXMLParamsType;
    { \bhƃvpeB }
    property Params: IXMLParamsType read Get_Params;
  end;

{ IXMLParamsType }

  IXMLParamsType = interface(IXMLNode)
    ['{394D6235-CF2B-40E5-BE8C-3D1A675211E1}']
    { vpeBQƊ֐ }
    function Get_Param: IXMLParamType;
    { \bhƃvpeB }
    property Param: IXMLParamType read Get_Param;
  end;

{ IXMLParamType }

  IXMLParamType = interface(IXMLNode)
    ['{36915DD1-FB5D-4280-ADE0-98E811857004}']
    { vpeBQƊ֐ }
    function Get_Value: IXMLValueType;
    { \bhƃvpeB }
    property Value: IXMLValueType read Get_Value;
  end;

{ IXMLValueType }

  IXMLValueType = interface(IXMLNode)
    ['{EBCF6943-4A52-40F7-A847-1449353DD08E}']
    { vpeBQƊ֐ }
    function Get_String_: UnicodeString;
    function Get_Int: Integer;
    function Get_Struct: IXMLStructType;
    function Get_Array_: IXMLArrayType;
    procedure Set_String_(Value: UnicodeString);
    procedure Set_Int(Value: Integer);
    { \bhƃvpeB }
    property String_: UnicodeString read Get_String_ write Set_String_;
    property Int: Integer read Get_Int write Set_Int;
    property Struct: IXMLStructType read Get_Struct;
    property Array_: IXMLArrayType read Get_Array_;
  end;

{ IXMLStructType }

  IXMLStructType = interface(IXMLNodeCollection)
    ['{1290F2B3-3C75-4BD0-82FF-1F5042D7FB64}']
    { vpeBQƊ֐ }
    function Get_Member(Index: Integer): IXMLMemberType;
    { \bhƃvpeB }
    function Add: IXMLMemberType;
    function Insert(const Index: Integer): IXMLMemberType;
    property Member[Index: Integer]: IXMLMemberType read Get_Member; default;
  end;

{ IXMLMemberType }

  IXMLMemberType = interface(IXMLNode)
    ['{33D08FB9-E315-4AB3-A16B-78A8E180631F}']
    { vpeBQƊ֐ }
    function Get_Name: UnicodeString;
    function Get_Value: IXMLValueType;
    procedure Set_Name(Value: UnicodeString);
    { \bhƃvpeB }
    property Name: UnicodeString read Get_Name write Set_Name;
    property Value: IXMLValueType read Get_Value;
  end;

{ IXMLArrayType }

  IXMLArrayType = interface(IXMLNode)
    ['{3929AD5B-3C2B-4725-A5DC-306B8A03A97D}']
    { vpeBQƊ֐ }
    function Get_Data: IXMLDataType;
    { \bhƃvpeB }
    property Data: IXMLDataType read Get_Data;
  end;

{ IXMLDataType }

  IXMLDataType = interface(IXMLNode)
    ['{7B18E8FC-C541-4093-9D10-62B52587187C}']
    { vpeBQƊ֐ }
    function Get_Value: IXMLValueType;
    { \bhƃvpeB }
    property Value: IXMLValueType read Get_Value;
  end;

{ O錾 }

  TXMLMethodResponseType = class;
  TXMLParamsType = class;
  TXMLParamType = class;
  TXMLValueType = class;
  TXMLStructType = class;
  TXMLMemberType = class;
  TXMLArrayType = class;
  TXMLDataType = class;

{ TXMLMethodResponseType }

  TXMLMethodResponseType = class(TXMLNode, IXMLMethodResponseType)
  protected
    { IXMLMethodResponseType }
    function Get_Params: IXMLParamsType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamsType }

  TXMLParamsType = class(TXMLNode, IXMLParamsType)
  protected
    { IXMLParamsType }
    function Get_Param: IXMLParamType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamType }

  TXMLParamType = class(TXMLNode, IXMLParamType)
  protected
    { IXMLParamType }
    function Get_Value: IXMLValueType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLValueType }

  TXMLValueType = class(TXMLNode, IXMLValueType)
  protected
    { IXMLValueType }
    function Get_String_: UnicodeString;
    function Get_Int: Integer;
    function Get_Struct: IXMLStructType;
    function Get_Array_: IXMLArrayType;
    procedure Set_String_(Value: UnicodeString);
    procedure Set_Int(Value: Integer);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLStructType }

  TXMLStructType = class(TXMLNodeCollection, IXMLStructType)
  protected
    { IXMLStructType }
    function Get_Member(Index: Integer): IXMLMemberType;
    function Add: IXMLMemberType;
    function Insert(const Index: Integer): IXMLMemberType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLMemberType }

  TXMLMemberType = class(TXMLNode, IXMLMemberType)
  protected
    { IXMLMemberType }
    function Get_Name: UnicodeString;
    function Get_Value: IXMLValueType;
    procedure Set_Name(Value: UnicodeString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLArrayType }

  TXMLArrayType = class(TXMLNode, IXMLArrayType)
  protected
    { IXMLArrayType }
    function Get_Data: IXMLDataType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLDataType }

  TXMLDataType = class(TXMLNode, IXMLDataType)
  protected
    { IXMLDataType }
    function Get_Value: IXMLValueType;
  public
    procedure AfterConstruction; override;
  end;

{ O[o֐ }

function GetmethodResponse(Doc: IXMLDocument): IXMLMethodResponseType;
function LoadmethodResponse(const FileName: string): IXMLMethodResponseType;
function NewmethodResponse: IXMLMethodResponseType;

const
  TargetNamespace = '';

implementation

{ O[o֐ }

function GetmethodResponse(Doc: IXMLDocument): IXMLMethodResponseType;
begin
  Result := Doc.GetDocBinding('methodResponse', TXMLMethodResponseType, TargetNamespace) as IXMLMethodResponseType;
end;

function LoadmethodResponse(const FileName: string): IXMLMethodResponseType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('methodResponse', TXMLMethodResponseType, TargetNamespace) as IXMLMethodResponseType;
end;

function NewmethodResponse: IXMLMethodResponseType;
begin
  Result := NewXMLDocument.GetDocBinding('methodResponse', TXMLMethodResponseType, TargetNamespace) as IXMLMethodResponseType;
end;

{ TXMLMethodResponseType }

procedure TXMLMethodResponseType.AfterConstruction;
begin
  RegisterChildNode('params', TXMLParamsType);
  inherited;
end;

function TXMLMethodResponseType.Get_Params: IXMLParamsType;
begin
  Result := ChildNodes['params'] as IXMLParamsType;
end;

{ TXMLParamsType }

procedure TXMLParamsType.AfterConstruction;
begin
  RegisterChildNode('param', TXMLParamType);
  inherited;
end;

function TXMLParamsType.Get_Param: IXMLParamType;
begin
  Result := ChildNodes['param'] as IXMLParamType;
end;

{ TXMLParamType }

procedure TXMLParamType.AfterConstruction;
begin
  RegisterChildNode('value', TXMLValueType);
  inherited;
end;

function TXMLParamType.Get_Value: IXMLValueType;
begin
  Result := ChildNodes['value'] as IXMLValueType;
end;

{ TXMLValueType }

procedure TXMLValueType.AfterConstruction;
begin
  RegisterChildNode('struct', TXMLStructType);
  RegisterChildNode('array', TXMLArrayType);
  inherited;
end;

function TXMLValueType.Get_String_: UnicodeString;
begin
  Result := ChildNodes['string'].Text;
end;

procedure TXMLValueType.Set_String_(Value: UnicodeString);
begin
  ChildNodes['string'].NodeValue := Value;
end;

function TXMLValueType.Get_Int: Integer;
begin
  Result := ChildNodes['int'].NodeValue;
end;

procedure TXMLValueType.Set_Int(Value: Integer);
begin
  ChildNodes['int'].NodeValue := Value;
end;

function TXMLValueType.Get_Struct: IXMLStructType;
begin
  Result := ChildNodes['struct'] as IXMLStructType;
end;

function TXMLValueType.Get_Array_: IXMLArrayType;
begin
  Result := ChildNodes['array'] as IXMLArrayType;
end;

{ TXMLStructType }

procedure TXMLStructType.AfterConstruction;
begin
  RegisterChildNode('member', TXMLMemberType);
  ItemTag := 'member';
  ItemInterface := IXMLMemberType;
  inherited;
end;

function TXMLStructType.Get_Member(Index: Integer): IXMLMemberType;
begin
  Result := List[Index] as IXMLMemberType;
end;

function TXMLStructType.Add: IXMLMemberType;
begin
  Result := AddItem(-1) as IXMLMemberType;
end;

function TXMLStructType.Insert(const Index: Integer): IXMLMemberType;
begin
  Result := AddItem(Index) as IXMLMemberType;
end;

{ TXMLMemberType }

procedure TXMLMemberType.AfterConstruction;
begin
  RegisterChildNode('value', TXMLValueType);
  inherited;
end;

function TXMLMemberType.Get_Name: UnicodeString;
begin
  Result := ChildNodes['name'].Text;
end;

procedure TXMLMemberType.Set_Name(Value: UnicodeString);
begin
  ChildNodes['name'].NodeValue := Value;
end;

function TXMLMemberType.Get_Value: IXMLValueType;
begin
  Result := ChildNodes['value'] as IXMLValueType;
end;

{ TXMLArrayType }

procedure TXMLArrayType.AfterConstruction;
begin
  RegisterChildNode('data', TXMLDataType);
  inherited;
end;

function TXMLArrayType.Get_Data: IXMLDataType;
begin
  Result := ChildNodes['data'] as IXMLDataType;
end;

{ TXMLDataType }

procedure TXMLDataType.AfterConstruction;
begin
  RegisterChildNode('value', TXMLValueType);
  inherited;
end;

function TXMLDataType.Get_Value: IXMLValueType;
begin
  Result := ChildNodes['value'] as IXMLValueType;
end;

end.
