unit fetchAddressByPostcode;

interface

uses xmldom, XMLDoc, XMLIntf;

type

{ O錾 }

  IXMLMethodCallType = interface;
  IXMLParamsType = interface;
  IXMLParamType = interface;
  IXMLValueType = interface;

{ IXMLMethodCallType }

  IXMLMethodCallType = interface(IXMLNode)
    ['{F1E82DA2-E7F9-40A4-9319-511CE3E03137}']
    { vpeBQƊ֐ }
    function Get_MethodName: UnicodeString;
    function Get_Params: IXMLParamsType;
    procedure Set_MethodName(Value: UnicodeString);
    { \bhƃvpeB }
    property MethodName: UnicodeString read Get_MethodName write Set_MethodName;
    property Params: IXMLParamsType read Get_Params;
  end;

{ IXMLParamsType }

  IXMLParamsType = interface(IXMLNode)
    ['{AB61E87D-4CA2-4182-B84A-6B9D186933E1}']
    { vpeBQƊ֐ }
    function Get_Param: IXMLParamType;
    { \bhƃvpeB }
    property Param: IXMLParamType read Get_Param;
  end;

{ IXMLParamType }

  IXMLParamType = interface(IXMLNode)
    ['{31429ACC-037B-4E3C-AC97-BAB21A1A1F36}']
    { vpeBQƊ֐ }
    function Get_Value: IXMLValueType;
    { \bhƃvpeB }
    property Value: IXMLValueType read Get_Value;
  end;

{ IXMLValueType }

  IXMLValueType = interface(IXMLNode)
    ['{E8119459-8BD0-416F-85EB-E62F45B7DD46}']
    { vpeBQƊ֐ }
    function Get_String_: UnicodeString;
    procedure Set_String_(Value: UnicodeString);
    { \bhƃvpeB }
    property String_: UnicodeString read Get_String_ write Set_String_;
  end;

{ O錾 }

  TXMLMethodCallType = class;
  TXMLParamsType = class;
  TXMLParamType = class;
  TXMLValueType = class;

{ TXMLMethodCallType }

  TXMLMethodCallType = class(TXMLNode, IXMLMethodCallType)
  protected
    { IXMLMethodCallType }
    function Get_MethodName: UnicodeString;
    function Get_Params: IXMLParamsType;
    procedure Set_MethodName(Value: UnicodeString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamsType }

  TXMLParamsType = class(TXMLNode, IXMLParamsType)
  protected
    { IXMLParamsType }
    function Get_Param: IXMLParamType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamType }

  TXMLParamType = class(TXMLNode, IXMLParamType)
  protected
    { IXMLParamType }
    function Get_Value: IXMLValueType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLValueType }

  TXMLValueType = class(TXMLNode, IXMLValueType)
  protected
    { IXMLValueType }
    function Get_String_: UnicodeString;
    procedure Set_String_(Value: UnicodeString);
  end;

{ O[o֐ }

function GetmethodCall(Doc: IXMLDocument): IXMLMethodCallType;
function LoadmethodCall(const FileName: string): IXMLMethodCallType;
function NewmethodCall: IXMLMethodCallType;

const
  TargetNamespace = '';

implementation

{ O[o֐ }

function GetmethodCall(Doc: IXMLDocument): IXMLMethodCallType;
begin
  Result := Doc.GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

function LoadmethodCall(const FileName: string): IXMLMethodCallType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

function NewmethodCall: IXMLMethodCallType;
begin
  Result := NewXMLDocument.GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

{ TXMLMethodCallType }

procedure TXMLMethodCallType.AfterConstruction;
begin
  RegisterChildNode('params', TXMLParamsType);
  inherited;
end;

function TXMLMethodCallType.Get_MethodName: UnicodeString;
begin
  Result := ChildNodes['methodName'].Text;
end;

procedure TXMLMethodCallType.Set_MethodName(Value: UnicodeString);
begin
  ChildNodes['methodName'].NodeValue := Value;
end;

function TXMLMethodCallType.Get_Params: IXMLParamsType;
begin
  Result := ChildNodes['params'] as IXMLParamsType;
end;

{ TXMLParamsType }

procedure TXMLParamsType.AfterConstruction;
begin
  RegisterChildNode('param', TXMLParamType);
  inherited;
end;

function TXMLParamsType.Get_Param: IXMLParamType;
begin
  Result := ChildNodes['param'] as IXMLParamType;
end;

{ TXMLParamType }

procedure TXMLParamType.AfterConstruction;
begin
  RegisterChildNode('value', TXMLValueType);
  inherited;
end;

function TXMLParamType.Get_Value: IXMLValueType;
begin
  Result := ChildNodes['value'] as IXMLValueType;
end;

{ TXMLValueType }

function TXMLValueType.Get_String_: UnicodeString;
begin
  Result := ChildNodes['string'].Text;
end;

procedure TXMLValueType.Set_String_(Value: UnicodeString);
begin
  ChildNodes['string'].NodeValue := Value;
end;

end.
