unit fetchAddressByPostcode;
interface

uses xmldom, XMLDoc, XMLIntf;
type

{ O錾 }

  IXMLMethodCallType = interface;
  IXMLParamsType = interface;
  IXMLParamType = interface;
  IXMLValueType = interface;

{ IXMLMethodCallType }

  IXMLMethodCallType = interface(IXMLNode)
    ['{A30FEFF1-F2DD-4B26-8974-DC2A1FDB19EB}']
    { vpeBQƊ֐ }
    function Get_MethodName: WideString;
    function Get_Params: IXMLParamsType;
    procedure Set_MethodName(Value: WideString);
    { \bhƃvpeB }
    property MethodName: WideString read Get_MethodName write Set_MethodName;
    property Params: IXMLParamsType read Get_Params;
  end;

{ IXMLParamsType }

  IXMLParamsType = interface(IXMLNode)
    ['{84BE60FE-050E-40F5-82BA-1B6AB8743771}']
    { vpeBQƊ֐ }
    function Get_Param: IXMLParamType;
    { \bhƃvpeB }
    property Param: IXMLParamType read Get_Param;
  end;

{ IXMLParamType }

  IXMLParamType = interface(IXMLNode)
    ['{F6232F85-425B-4F9D-B0F4-364A3A69AA63}']
    { vpeBQƊ֐ }
    function Get_Value: IXMLValueType;
    { \bhƃvpeB }
    property Value: IXMLValueType read Get_Value;
  end;

{ IXMLValueType }

  IXMLValueType = interface(IXMLNode)
    ['{8140472F-DB57-4BC7-9455-77765AEEBEA3}']
    { vpeBQƊ֐ }
    function Get_String_: WideString;
    procedure Set_String_(Value: WideString);
    { \bhƃvpeB }
    property String_: WideString read Get_String_ write Set_String_;
  end;

{ O錾 }

  TXMLMethodCallType = class;
  TXMLParamsType = class;
  TXMLParamType = class;
  TXMLValueType = class;

{ TXMLMethodCallType }

  TXMLMethodCallType = class(TXMLNode, IXMLMethodCallType)
  protected
    { IXMLMethodCallType }
    function Get_MethodName: WideString;
    function Get_Params: IXMLParamsType;
    procedure Set_MethodName(Value: WideString);
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamsType }

  TXMLParamsType = class(TXMLNode, IXMLParamsType)
  protected
    { IXMLParamsType }
    function Get_Param: IXMLParamType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLParamType }

  TXMLParamType = class(TXMLNode, IXMLParamType)
  protected
    { IXMLParamType }
    function Get_Value: IXMLValueType;
  public
    procedure AfterConstruction; override;
  end;

{ TXMLValueType }

  TXMLValueType = class(TXMLNode, IXMLValueType)
  protected
    { IXMLValueType }
    function Get_String_: WideString;
    procedure Set_String_(Value: WideString);
  end;

{ O[o֐ }

function GetmethodCall(Doc: IXMLDocument): IXMLMethodCallType;
function LoadmethodCall(const FileName: WideString): IXMLMethodCallType;
function NewmethodCall: IXMLMethodCallType;

const
  TargetNamespace = '';

implementation

{ O[o֐ }

function GetmethodCall(Doc: IXMLDocument): IXMLMethodCallType;
begin
  Result := Doc.GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

function LoadmethodCall(const FileName: WideString): IXMLMethodCallType;
begin
  Result := LoadXMLDocument(FileName).GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

function NewmethodCall: IXMLMethodCallType;
begin
  Result := NewXMLDocument.GetDocBinding('methodCall', TXMLMethodCallType, TargetNamespace) as IXMLMethodCallType;
end;

{ TXMLMethodCallType }

procedure TXMLMethodCallType.AfterConstruction;
begin
  RegisterChildNode('params', TXMLParamsType);
  inherited;
end;

function TXMLMethodCallType.Get_MethodName: WideString;
begin
  Result := ChildNodes['methodName'].Text;
end;

procedure TXMLMethodCallType.Set_MethodName(Value: WideString);
begin
  ChildNodes['methodName'].NodeValue := Value;
end;

function TXMLMethodCallType.Get_Params: IXMLParamsType;
begin
  Result := ChildNodes['params'] as IXMLParamsType;
end;

{ TXMLParamsType }

procedure TXMLParamsType.AfterConstruction;
begin
  RegisterChildNode('param', TXMLParamType);
  inherited;
end;

function TXMLParamsType.Get_Param: IXMLParamType;
begin
  Result := ChildNodes['param'] as IXMLParamType;
end;

{ TXMLParamType }

procedure TXMLParamType.AfterConstruction;
begin
  RegisterChildNode('value', TXMLValueType);
  inherited;
end;

function TXMLParamType.Get_Value: IXMLValueType;
begin
  Result := ChildNodes['value'] as IXMLValueType;
end;

{ TXMLValueType }

function TXMLValueType.Get_String_: WideString;
begin
  Result := ChildNodes['string'].Text;
end;

procedure TXMLValueType.Set_String_(Value: WideString);
begin
  ChildNodes['string'].NodeValue := Value;
end;

end.
